/* modified preselect-lock.p. */
/* Preselect locking testcases. */

message "press 1-9 or a-b!".

readkey.

def query q for person.
def buffer x-person for person.
def var saved as character init "".

def var i as integer.
i = 3.

do transaction:

 if chr(lastkey) = "1"
 then do:
   find first person where person.schedule[4] = "aaa".
   display person.emp-num
        person.first-name
        person.last-name.
   pause message "lock acquired".
 end.

 else if chr(lastkey) = "2"
 then do:
   find first person where person.schedule[i] = "vvv".
   update person.emp-num
        person.first-name
        person.last-name.
   pause message "lock acquired".
 end.

 else if chr(lastkey) = "3"
 then do:
   do preselect each person by person.schedule[2]:
	find last person where person.schedule[2] = person.schedule[3].
	pause message "lock acquired".
   end.
 end.

 else if chr(lastkey) = "4"
 then do:
   do preselect each person exclusive-lock by person.schedule[i + 1]:
	find last person.
	pause message "lock acquired".
   end.
 end.

 else if chr(lastkey) = "5"
 then do:
   open query q preselect each person exclusive-lock by person.emp-num.
   get first q.
   message string(person.emp-num).
   get last q.
   message string(person.emp-num).  
   pause message "lock acquired".
   
   
   find first person exclusive-lock.
   message string(person.emp-num).
   find next person exclusive-lock.
 end.

 else if chr(lastkey) = "6"
 then do:
   repeat preselect each person no-lock by person.emp-num:
	find first person.
        message string(person.emp-num).
        find last person.
        message string(person.emp-num).  
	pause message "lock acquired".
   end.
   
   find first person exclusive-lock.
 end.

 else if chr(lastkey) = "7"
 then do:
   do preselect each person by person.emp-num desc:
	find first person.
        pause message "lock1 acquired".

        find first x-person where x-person.emp-num = 123 no-lock.
        pause message "lock2 acquired".
   end.
 end.

 else if chr(lastkey) = "8"
 then do:
   find first person where person.emp-num = 123.
   pause message "lock1 acquired".
   find first x-person where x-person.emp-num = 123 no-lock.
   pause message "lock2 acquired".   
 end.

 else if chr(lastkey) = "9"
 then do:
   do preselect each person exclusive-lock by person.emp-num:
	find last person.
	pause message "lock1 acquired".
   end.
   
   find first person share-lock.
   pause message "lock2 acquired".
 end.

 else if chr(lastkey) = "a"
 then do:
   do preselect each person share-lock by person.emp-num:
	find last person.
	pause message "lock1 acquired".

        do preselect each x-person exclusive-lock by x-person.emp-num:
	   find last x-person.
	   pause message "lock2 acquired".
       end.
   end.
 end.

 else do:
   saved = chr(lastkey).
 end.

 pause message "after cycle".

end.

 if saved = "b"
 then do:
   do transaction:
     do preselect each person share-lock by person.emp-num:
	find last person.
	pause message "lock1 acquired".
     end.
   end.

   pause message "lock2 acquired".

   do transaction:
     do preselect each person share-lock by person.emp-num:
	find last person.
	pause message "lock3 acquired".
     end.
   end.
 end.


pause message "end of test".

def temp-table tt
   field num as int
   field other as int.
